(function() {
  var $, AssetCollection, AssetGrid, Backbone, Handlebars, editorAssetsThumbnails, _;

  _ = require('underscore');

  $ = global.$;

  $ || ($ = require('jquery-browserify'));

  Backbone = require('backbone');

  Backbone.$ = $;

  Handlebars = require('handlebars');

  require('./CommonHandlebarsHelpers.js');

  AssetGrid = require('./AssetGrid.js').AssetGrid;

  AssetCollection = require('./asset/model/AssetCollection.js').AssetCollection;

  editorAssetsThumbnails = require('./templates.js').editorAssetsThumbnails;

  exports.AssetCollectionAssetGrid = AssetGrid.extend({
    events: {
      'click img': 'imageClicked'
    },
    imageClicked: function(event) {
      var id, target;

      target = event.target;
      id = this.$(target).attr('image-id');
      return this.trigger('assetCollectionAssetGrid:imageSelected', id);
    },
    initialize: function() {
      this.template = editorAssetsThumbnails;
      this.collectionClass = AssetCollection;
      return this.setupCollectionListeners();
    },
    setupCollectionListeners: function() {
      var _this = this;

      this.stopListening(this.collection, "all");
      this.listenTo(this.collection, "all", function() {
        return _this.render();
      });
      return this.render();
    },
    render: function() {
      this.undelegateEvents();
      this.$el.html(this.template({
        images: this.collection.toJSON()
      }));
      return this.delegateEvents();
    }
  });

}).call(this);
