(function() {
  var $, Backbone, uploadItem, _;

  $ = global.$;

  $ || ($ = require('jquery-browserify'));

  _ = require('underscore');

  Backbone = require('backbone');

  Backbone.$ = $;

  uploadItem = require('./templates.js').uploadItem;

  exports.UploadItem = Backbone.View.extend({
    addEventListeners: function() {
      this.stopListening(this.model, "all", this.render);
      return this.listenTo(this.model, "all", this.render);
    },
    cancelUpload: function() {
      var request, requestId;

      request = this.model.requests[0];
      if (request != null) {
        requestId = request.requestId;
      }
      return this.model.cancel(requestId);
    },
    events: {
      'click td.start button.btn': "startUpload",
      'click td.cancel button.btn': 'cancelUpload'
    },
    initialize: function() {
      var template;

      template = this.options.template;
      template || (template = uploadItem);
      this.template = template;
      return this.addEventListeners();
    },
    render: function() {
      var $item, context;

      if (this.model.get('progress') === 1) {
        return this.remove();
      } else {
        context = {
          id: this.model.cid,
          filename: this.model.get('name'),
          size: this.model.get('size'),
          hasError: false,
          valid: true,
          autoUpload: true,
          progress: this.model.get('progress') * 100,
          startMsg: "Upload File",
          cancelMsg: "Cancel Upload"
        };
        this.undelegateEvents();
        $item = this.getItemElement();
        if ($item.length > 0) {
          $item.replaceWith(uploadItem(context));
        } else {
          this.$el.append(uploadItem(context));
        }
        this.delegateEvents(this.events);
        return this;
      }
    },
    getItemElement: function() {
      return this.$('#' + this.model.cid, this.$el);
    },
    startUpload: function() {
      return this.model.upload();
    },
    remove: function() {
      var $item;

      this.stopListening();
      $item = this.getItemElement();
      if ($item.length > 0) {
        $item.addClass('fade out');
        _.delay(function() {
          return $item.remove();
        }, 301);
      }
      return this;
    }
  });

}).call(this);
