(function() {
  var AssetModel, Backbone, notify;

  Backbone = require('backbone');

  notify = require('../../notify.js').notify;

  AssetModel = Backbone.Model.extend({
    defaults: {
      filename: "",
      description: "",
      contentType: "",
      uploadedOn: new Date(),
      uploadedBy: "",
      labels: []
    },
    urlRoot: '/_/api/asset',
    _selected: false,
    _uploadedOnDate: null,
    setSelected: function(selected) {
      this._selected = selected;
      return this.trigger('selectedchanged', this);
    },
    isSelected: function() {
      return this._selected;
    },
    isPdf: function() {
      var ctype;

      ctype = this.get("contentType");
      return ctype.indexOf("/pdf") > -1;
    },
    isText: function() {
      var ctype;

      ctype = this.get("contentType");
      return ctype.indexOf("text/") === 0 || ctype.indexOf("/msword") > -1 || ctype.indexOf("/rtf") > -1;
    },
    isImage: function() {
      var ctype;

      ctype = this.get("contentType");
      return ctype.indexOf("image/") === 0;
    },
    isTrash: function() {
      return this.get('trashed');
    },
    notifyLabelChange: function() {
      return this.trigger('change:labels');
    },
    uploadedOn: function() {
      return this._uploadedOnDate || (this._uploadedOnDate = new Date(this.get('uploadedOn')));
    },
    trash: function() {
      this.set('trashed', true);
      return this.save();
    }
  });

  exports.AssetModel = AssetModel;

}).call(this);
