_ = require 'underscore'
$ = global.$
$ or= require 'jquery-browserify'
Backbone = require 'backbone'
Backbone.$ = $
Handlebars = require 'handlebars'
require './CommonHandlebarsHelpers.js'
{AssetGrid} = require './AssetGrid.js'
{AssetCollection} = require './asset/model/AssetCollection.js'
{editorAssetsThumbnails} = require './templates.js'

exports.AssetCollectionAssetGrid = AssetGrid.extend
  events:
    'click img': 'imageClicked'

  imageClicked:(event) ->
    target = event.target
    id = @$(target).attr('image-id')
    @trigger('assetCollectionAssetGrid:imageSelected', id)
  
  initialize: ->
    @template = editorAssetsThumbnails
    @collectionClass = AssetCollection
    @setupCollectionListeners()

  setupCollectionListeners: ->
    @.stopListening(@collection, "all")
    @.listenTo(@collection, "all", => @render())
    @render()

  render: ->
    @undelegateEvents()
    @$el.html(@template(images: @collection.toJSON()))
    @delegateEvents()
