Handlebars = require 'handlebars'
dateFormat = @dateFormat
{ContentTypeHelpers} = require './ContentTypeHelpers.js'


Handlebars.registerHelper("thumbnail", (id, contentType, w = 100, h = 100) ->
  contentType = contentType.toLowerCase()
  if contentType == "image/jpeg" or
    contentType == "image/png" or
    contentType == "image/gif" or
    contentType == "image/bmp"
      w = if isFinite(w)
        w
      else
        100
      h = if isFinite(h)
        h
      else
        100
      "/assets/files/" + id + "/thumbnail/"+w+"/"+h
  else
    "/assets/editor/img/file-types/" + ContentTypeHelpers.contentTypeToIcon(contentType)
)
  
Handlebars.registerHelper("url", (id) ->
  "/assets/files/" + id
)
  
Handlebars.registerHelper("dateformat", (date) ->
  new Handlebars.SafeString(dateFormat(new Date(date), "mm/dd/yyyy"))
)

Handlebars.registerHelper("datetimeformat", (date) ->
  new Handlebars.SafeString(dateFormat(new Date(date), "ddd mmm dd yyyy h:MM tt"))
)
  
Handlebars.registerHelper("filesizeformat", (filesize) ->
  if Math.pow(10,6) > filesize
    (Math.round(filesize / 10) / 100) + " KB"
  else
    (Math.round(filesize / 10000) / 100) + " MB"
)

Handlebars.registerHelper("filetype", (contentTypeOrFilename) ->
  # convert to a content type if its a file
  if contentTypeOrFilename.indexOf("/") < 0
    contentTypeOrFilename = ContentTypeHelpers.extensionToContentType(contentTypeOrFilename)

  icon = ContentTypeHelpers.contentTypeToIcon(contentTypeOrFilename)
  icon = icon.slice(0, icon.indexOf('.')).toUpperCase()
  if icon == "DEFAULT"
    "File"
  else
    icon
)
  
Handlebars.registerHelper("getIcon", (network) ->
  if network?
    network.replace(" ", "-").replace("!", "").toLowerCase()
  else
    "branch"
)
	  
Handlebars.registerHelper("replaceSpace", (text) ->
  text = text.replace(/\s/g, "-").replace("!","").toLowerCase()
)
	  
Handlebars.registerHelper("getLocationType", (network) ->
  if network?
    "atm"
  else
    "branch"
)

Handlebars.registerHelper("roundNumber", (num) ->
  num.toFixed(2)
)

Handlebars.registerHelper("isUnread", (read) ->
  if read
    ""
  else
    "unread"
)

Handlebars.registerHelper("userAvatar", (userId) ->
  "/_/api/user/" + userId + "/image"
)
