ContentTypeHelpers =

  pptIcon: "ppt.png"

  xlsIcon: "xls.png"

  docIcon: "doc.png"

  defaultIcon: "default.png"

  contentTypeToIconMap:

    "video/msvideo":                  "avi.png"

    "text/csv":                       "csv.png"

    "video/x-flv":                    "flv.png"

    "image/gif":                      "gif.png"

    "text/html":                      "html.png"

    "image/jpeg":                     "jpg.png"

    "video/quicktime":                "mov.png"

    "audio/mpeg3":                    "mp3.png"

    "video/mpeg":                     "mpg.png"

    "application/pdf":                "pdf.png"

    "image/png":                      "png.png"

    "application/vnd.ms-powerpoint":  @pptIcon

    "application/x-shockwave-flash" : "swf.png"

    "text/plain":                     "txt.png"

    "application/xml":                "xml.png"

    "application/zip":                "zip.png"

    "application/vnd.ms-excel":       @xlsIcon

    "application/msword":             @docIcon

    "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": @xlsIcon

    "application/vnd.openxmlformats-officedocument.wordprocessingml.document" : @docIcon

    "application/vnd.openxmlformats-officedocument.presentationml.presentation" : @pptIcon

  extensionToContentTypeMap:

    "csv" : "text/csv"

    "txt" : "text/plain"

    "htm" : "text/html"

    "html" : "text/html"

    "php" : "text/html"

    "css" : "text/css"

    "js" : "application/javascript"

    "json" : "application/json"

    "xml" : "application/xml"

    "swf" : "application/x-shockwave-flash"

    "flv" : "video/x-flv"

    # images
    "png" : "image/png"

    "jpe" : "image/jpeg"

    "jpeg" : "image/jpeg"

    "jpg" : "image/jpeg"

    "gif" : "image/gif"

    "bmp" : "image/bmp"

    "ico" : "image/vnd.microsoft.icon"

    "tiff" : "image/tiff"

    "tif" : "image/tiff"

    "svg" : "image/svg+xml"

    "svgz" : "image/svg+xml"

    # archives
    "zip" : "application/zip"

    "rar" : "application/x-rar-compressed"

    "exe" : "application/x-msdownload"

    "msi" : "application/x-msdownload"

    "cab" : "application/vnd.ms-cab-compressed"

    "tar" : "application/x-tar"

    # audio/video
    "qt" : "video/quicktime"

    "mov" : "video/quicktime"

    "mpeg" : "video/mpeg"

    "mpg" : "video/mpeg"

    "mpe" : "video/mpeg"

    "mp3" : "audio/mpeg3"

    "wav" : "audio/wav"

    "aiff" : "audio/aiff"

    "aif" : "audio/aiff"

    "avi" : "video/msvideo"

    "wmv" : "video/x-ms-wmv"

    # adobe
    "pdf" : "application/pdf"

    "psd" : "image/vnd.adobe.photoshop"

    "ai" : "application/postscript"

    "eps" : "application/postscript"

    "ps" : "application/postscript"

    # ms office
    "doc" : "application/msword"

    "docx" : "application/vnd.openxmlformats-officedocument.wordprocessingml.document"

    "rtf" : "application/rtf"

    "ppt" : "application/vnd.ms-powerpoint"

    "pps" : "application/vnd.ms-powerpoint"

    "pptx": "application/vnd.openxmlformats-officedocument.presentationml.presentation"

    "xls" : "application/vnd.ms-excel"

    "xlsx": "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"

    "xlt" : "application/vnd.ms-excel"

    "xlm" : "application/vnd.ms-excel"

    "xld" : "application/vnd.ms-excel"

    "xla" : "application/vnd.ms-excel"

    "xlc" : "application/vnd.ms-excel"

    "xlw" : "application/vnd.ms-excel"

    "xll" : "application/vnd.ms-excel"

    # open office
    "odt" : "application/vnd.oasis.opendocument.text"

    "ods" : "application/vnd.oasis.opendocument.spreadsheet"

  contentTypeToIcon: (contentType) ->
    icon = @contentTypeToIconMap[contentType.toLowerCase()]
    if icon
      icon
    else
      @defaultIcon

  extensionToContentType: (filename) ->
    extension = if( (periodPos = filename.lastIndexOf(".")) > -1 )
      filename.slice(periodPos+1)
    else
      filename
    contentType = @extensionToContentTypeMap[extension.toLowerCase()]
    contentType or= ""

exports.ContentTypeHelpers = ContentTypeHelpers