$ = global.$
$ or= require 'jquery-browserify'
_ = require 'underscore'
Backbone = require 'backbone'
Backbone.$ = $

exports.FileUpload = Backbone.Model.extend
  defaults:
    name: ""
    type: ""
    size: 0
    maxFileSize: 50000000
    pending: false
    progress: 0.00
    complete: false
    file: ""
  initialize: ->
    @listenTo(@, 'change:progress', @progressChanged)
  cancel: (uploadId) ->
    for upload in @requests when upload.requestId is uploadId
      upload.request.abort()
    @requests = for request in @requests when request.requestId isnt uploadId
      request
  progressChanged: ->
    if 0 < @get('progress') < 100
      @set(pending: true)
    else if @get('progress') is 100
      @set(pending: false, complete: true)
      @trigger('fileupload:complete', @)
  requests: []
  upload: (file) ->
    if(file?)
      @set(name: file.name, type: file.type, pending: true, complete:false, file: file)
    @trigger('fileupload:uploadstart', @)
    @save()
  save: (attributes, options) ->
    @sync("create", @, options)
  sync: (method, model, options) ->
    # Replaces jquery's default xhr object to
    # allow for file uploads.
    if method == "create"
      if(not options?.url?)
        url = @url()
      $.ajax(
        xhr: =>
          xhr = new window.XMLHttpRequest()
          xhr.upload.addEventListener(
            "progress",
            (event) ->
              model.set(progress: if event.lengthComputable then event.loaded / event.total else NaN)
              model.trigger('change', model, {})
            false
          )
          xhr
        type: 'POST'
        url: url
        processData: false
        data: ( ->
          formData = new window.FormData()
          formData.append("files", model.get("file"))
          formData
        )()
        contentType: false
      ).done(
        (data, status, jqXHR) ->
          options.success?(data)
          model.set(_.extend(model.parse(data), complete:true, pending: false, progress: 100))
          model.trigger('sync', model, data, options)
      ).fail(
        (jqXHR, textStatus, errorThrown) ->
          options.error?(model, errorThrown, options)
          model.trigger('error', model, jqXHR, options)
      )
    else Backbone.sync.apply(@, arguments)