_ = require 'underscore'
$ = global.$
$ or= require 'jquery-browserify'
Backbone = require 'backbone'
Backbone.$ = $
{ContentTypeHelpers} = require './ContentTypeHelpers.js'
{LocationDialogAssetGrid} = require './LocationDialogAssetGrid.js'
{locationsFileDialog} = require './templates.js'
{Uploader} = require './Uploader.js'

exports.LocationsFileDialogView = Backbone.View.extend
  events:
    'click #upload-a-trigger': 'toggleUploadView'
  initialize: ->
    @children = []
    @uploader = {}
    @collection = @options.collection
    @collection or= new Backbone.Collection()
    @template = @options.template
    @template or= locationsFileDialog
    @addCollectionListeners()
  addCollectionListeners: ->
    @listenTo(@collection, "all", => @renderChildViews())
  hide: ->
    @render()
    @$('#insert-image-modal', @$el).modal('hide')
  imageSelected:(id) ->
    @trigger('locationsFileDialogView:imageSelected', id)
  render: ->
    @$el.html(@template())
    @$('#upload-files').css('height':'119px;')
    @renderChildViews()
    #duck type uploader
    if not @uploader.render?
      @uploader = new Uploader(el: @$('#upload-files div.well-inner'))
    @uploader.render()
    @
  renderChildViews: ->
    @removeChildren()
    @$('.asset-grid.editor-asset-grid', @$el).html('<div id="gridBody"></div>')
    @children = [
      new LocationDialogAssetGrid(
        el: @$('#gridBody', @$el),
        collection: @collection
      ).render()
    ]
    @setupChildViewListeners()
  setupChildViewListeners: ->
    if @children.length > 0
      _.each(@children,
        (child) =>
          @stopListening(child, 'assetCollectionAssetGrid:imageSelected', @imageSelected)
          @listenTo(child, 'assetCollectionAssetGrid:imageSelected', @imageSelected)
      )
  show: ->
    @render()
    @$('#insert-image-modal', @$el).modal('show')
  toggleUploadView: (event) ->
    hiding = @$('#upload-files.collapse').hasClass('in')
    if hiding
      @$('#upload-files.collapse.in').collapse('hide')
      @collection.fetch()
    else
      @$('#upload-files.collapse').collapse('show')
    event.originalEvent.stopPropagation()
    event.originalEvent.preventDefault()
    event.stopPropagation()
    event.preventDefault()
  uploadDone: ->
    @collection.fetch()
  remove: ->
    @stopListening()
    @removeChildren()
    if @uploader.render?
      @uploader.remove()
      @uploader = {}
    @$el.html('')
  removeChildren: ->
    _.each(@children, (child) -> child.remove())
    

