$ = global.$
$ or= require 'jquery-browserify'
_ = require 'underscore'
Backbone = require 'backbone'
Backbone.$ = $
{UploadItem} = require './UploadItem.js'
{uploadItem, uploader} = require './templates.js'
{FileUploads} = require './FileUploads.js'


exports.Uploader = Backbone.View.extend
  addCollectionListeners: ->
    @stopListening(@collection, "create add remove", @render)
    @listenTo(@collection, "create add remove", @render)
    @stopListening(@collection, "fileupload:complete", @completeHandler)
    @listenTo(@collection, "fileupload:complete", @completeHandler)
  dragLeave: (event) ->
    event.stopPropagation()
    event.originalEvent.stopImmediatePropagation()
    event.originalEvent.preventDefault()
    event.preventDefault()
    @$('.hero-unit').css(border:'3px dashed #ffffff')
  cancelDrag: (event) ->
    event.stopPropagation()
    event.originalEvent.stopImmediatePropagation()
    event.originalEvent.preventDefault()
    event.preventDefault()
    @$('.hero-unit').css(border:'3px dashed #5bb75b')
  highlightDrop: (event) ->
    event.stopPropagation()
    event.originalEvent.stopImmediatePropagation()
    event.originalEvent.preventDefault()
    event.preventDefault()
    @$('.hero-unit').css(border:'3px dashed #ffffff')
  completeHandler: (model) ->
    @collection.remove(model)
  createFileObject: (file) ->
    filesObj = {file: file}
    @collection.create(_.extend(filesObj, file))
  events:
    'click #addFiles': 'selectFiles'
    'dragenter': 'highlightDrop'
    'change .uploader': 'uploadFiles'
    'dragover': 'cancelDrag'
    'dragleave': 'dragLeave'
    'drop': 'getDroppedFiles'
  getDroppedFiles: (event) ->
    _.each event.originalEvent.dataTransfer.files, (file) => @createFileObject(file)
    event.originalEvent.stopImmediatePropagation()
    event.originalEvent.preventDefault()
    event.stopImmediatePropagation()
    event.preventDefault()
    @$('.hero-unit').css(border:'3px dashed #ffffff')
  initialize: ->
    {collection} = @options
    collection ?= new FileUploads()
    @collection = collection
    {template} = @options
    template or= uploader
    @template = template
    @addCollectionListeners()
  render: ->
    @$el.html(@template())
    @renderChildViews()
    @
  renderChildViews: ->
    @removeChildren()
    if @$(@$el).find('tbody.files').length <= 0
      @$(@$el).find('table').append('<tbody class="files"></tbody>')
    $tbody = _.head(@$('tbody.files').get())
    @children = @collection.map((model) ->
      new UploadItem(
        model: model
        el: $tbody
        template: uploadItem
      ).render()
    )
    @
  selectFiles: (event) ->
    @undelegateEvents()
    @$('input[type=file][multiple].uploader').remove()
    @$el.append('<input type="file" class="uploader" multiple style="display:none"/>')
    @delegateEvents(@events)
    @$('input[type=file][multiple].uploader').click()
    event.preventDefault()
  remove: ->
    @stopListening()
    @removeChildren()
    @$el.html('')
    @
  removeChildren: ->
    _.each(@children, (view) -> view.remove())
  uploadFiles: ->
    _.each( _.head(@$('input[type=file][multiple].uploader').get()).files,
      (file) => @createFileObject(file))
    