Backbone = require('backbone')
{notify} = require '../../notify.js'

AssetModel = Backbone.Model.extend
  defaults:
    filename: ""
    description: ""
    contentType: ""
    uploadedOn:new Date()
    uploadedBy:""
    labels: []

  urlRoot: '/_/api/asset'

  _selected: false
  _uploadedOnDate: null

  setSelected: (selected) ->
    @_selected = selected
    @trigger('selectedchanged', @)

  isSelected: ->
    @_selected

  isPdf: ->
    ctype = @get("contentType")
    ctype.indexOf("/pdf") > -1

  isText: ->
    ctype = @get("contentType")
    ctype.indexOf("text/") == 0 or
    ctype.indexOf("/msword") > -1 or
    ctype.indexOf("/rtf") > -1

  isImage: ->
    ctype = @get("contentType")
    ctype.indexOf("image/") == 0

  isTrash: ->
    @get('trashed')

  notifyLabelChange: ->
    @trigger('change:labels')


  uploadedOn: ->
    @_uploadedOnDate or= new Date(@get('uploadedOn'))

  trash: ->
    @set('trashed',true)
    @save()
    
exports.AssetModel = AssetModel
