chai = require('chai')
should = chai.should()
{describe} = require '../../coffeescript/describe.coffee'
{expect} = chai
{editorAssetsThumbnails} = require '../../../../lib/templates.js'
_ = require 'underscore'
$ = require 'jquery-browserify'
Handlebars = require 'handlebars'
require '../../../main/coffeescript/CommonHandlebarsHelpers.coffee'
{AssetCollection} = require '../../../main/coffeescript/asset/model/AssetCollection.coffee'
{AssetTestData} = require '../../coffeescript/asset/spec/AssetTestData.coffee'

describe('templates',
  ->
    describe('#editorAssetsThumbnails'
      ->
        beforeEach (done) ->
          @collection = new AssetCollection().add(AssetTestData)
          done()

        afterEach (done) ->
          @collection = {}
          done()

        it 'should exist',
          (done) ->
            expect(editorAssetsThumbnails).to.exist
            done()

        it 'should be a Function',
          (done) ->
            editorAssetsThumbnails.should.be.an.instanceof Function
            done()

        it 'should output the propert html',
          (done) ->
            editorAssetsThumbnails(images: @collection.toJSON()).replace(///\s{2,}///g, "").should.equal """<ul class="thumbnails"><li><div class="img JPG">        <figure>          <img src="/assets/files/fca244b0-9bcd-11e2-8e1a-60334b0eb8b6/thumbnail/160/130" image-id="fca244b0-9bcd-11e2-8e1a-60334b0eb8b6" />        </figure>      </div>      <strong><span rel="tooltip" title="Winter.jpg">Winter.jpg</span></strong>    </li>          <li>      <div class="img PNG">        <figure>          <img src="/assets/files/077fa3f0-9bce-11e2-8e1a-60334b0eb8b6/thumbnail/160/130" image-id="077fa3f0-9bce-11e2-8e1a-60334b0eb8b6" />        </figure>      </div>      <strong><span rel="tooltip" title="pnggrad8rgb.png">pnggrad8rgb.png</span></strong>    </li>          <li>      <div class="img JPG">        <figure>          <img src="/assets/files/0dde0ac0-9bce-11e2-8e1a-60334b0eb8b6/thumbnail/160/130" image-id="0dde0ac0-9bce-11e2-8e1a-60334b0eb8b6" />        </figure>      </div>      <strong><span rel="tooltip" title="red_square.jpg">red_square.jpg</span></strong>    </li>    </ul>""".replace(///\s{2,}///g, "") + "\n"
            done()
    )
)