chai = require('chai')
sinon = require 'sinon'
sinonChai = require 'sinon-chai'
chai.use(sinonChai)
should = chai.should()
{expect} = chai
{describe} = require './describe.coffee'
$ = require 'jquery-browserify'
_ = require 'underscore'
Backbone = require('backbone')
Backbone.$ = $
{AssetGrid} = require '../../../dist/AssetGrid.js'

describe('AssetGrid',
  ->
    beforeEach (done) ->
      $('#fixtures').html('<div id="test-asset-grid"></div>')
      @view = new AssetGrid
        el: '#test-asset-grid'
      done()

    afterEach (done) ->
      @view = {}
      $('#fixtures').html('')
      done()

    it 'should exist',
      (done) ->
        expect(AssetGrid).to.exist
        done()

    it 'should be a backbone view',
      (done) ->
        @view.should.be.an.instanceof Backbone.View
        done()

    it 'should be an AssetGrid',
      (done) ->
        @view.should.be.an.instanceof AssetGrid
        done()

    it 'should have a collectionClass member',
      (done) ->
        expect(@view.collectionClass).to.exist
        done()

    it '#collectionClass should be Backbone.Collection',
      (done) ->
        @view.collectionClass.should.deep.equal Backbone.Collection
        done()

    it 'should have a template member',
      (done) ->
        expect(@view.template).to.exist
        done()

    it '#template should be a Function',
      (done) ->
        @view.template.should.be.an.instanceof Function
        done()

    it '#template() should not exist',
      (done) ->
        expect(@view.template()).not.to.exist
        done()

    it 'should have a collection member',
      (done) ->
        expect(@view.collection).to.exist
        done()

    it '#collection should be a Backbone.Collection',
      (done) ->
        @view.collection.should.be.an.instanceof Backbone.Collection
        done()

    it '#filter should exist',
      (done) ->
        expect(@view.filter).to.exist
        done()

    it '#addCollectionListeners should exist',
      (done) ->
        expect(@view.addCollectionListeners).to.exist
        done()

    it '#refreshCollection should exist',
      (done) ->
        expect(@view.refreshCollection).to.exist
        done()
)