$ = global.$
$ or= require 'jquery-browserify'
Backbone = require 'backbone'
Backbone.$ = $
{describe} = require './describe.coffee'
chai = require 'chai'
sinon = require 'sinon'
sinonChai = require 'sinon-chai'
chai.use(sinonChai)
should = chai.should()
{expect} = chai
{FileUpload} = require '../../../dist/FileUpload.js'
{FileUploads} = require '../../../dist/FileUploads.js'


describe('FileUploads',
  ->
    beforeEach (done) ->
      @FileUploadMock = sinon.mock(FileUpload)
      #mock file upload model so that we don't have to rely on it
      @FileUploads = FileUploads.extend model: @FileUploadMock
      @uploads = new @FileUploads()
      done()

    afterEach (done) ->
      @FileUploadMock.restore()
      @FileUploads = {}
      @uploads = {}
      done()
    
    it 'should exist',
      (done) ->
        expect(FileUploads).to.exist
        done()

    it 'should be a Backbone Collection',
      (done) ->
        @uploads.should.be.an.instanceof Backbone.Collection
        done()

    describe('#model',
      ->
        it 'should exist',
          (done) ->
            expect(@uploads.model).to.exist
            done()

        it 'should be FileUpload',
          (done) ->
            @uploads.model.should.deep.equal @FileUploadMock
            done()
    )

    describe('#url',
      ->
        it 'should exist',
          (done) ->
            expect(@uploads.url).to.exist
            done()

        it 'should be "/_/api/asset"',
          (done) ->
            @uploads.url.should.equal '/_/api/asset'
            done()
    )
)