chai = require('chai')
sinon = require 'sinon'
sinonChai = require 'sinon-chai'
chai.use(sinonChai)
should = chai.should()
{expect} = chai
{describe} = require './describe.coffee'
$ = require 'jquery-browserify'
_ = require 'underscore'
Backbone = require('backbone')
Backbone.$ = $
{LocationDialogAssetGrid} = require '../../../dist/LocationDialogAssetGrid.js'
{AssetCollectionAssetGrid} = require '../../../dist/AssetCollectionAssetGrid.js'
{AssetGrid} = require '../../../dist/AssetGrid.js'
{AssetCollection} = require '../../../dist/asset/model/AssetCollection.js'
{AssetTestData} = require './asset/spec/AssetTestData.coffee'
{editorAssetsThumbnails} = require '../../../dist/templates.js'
{ContentTypeHelpers} = require '../../../dist/ContentTypeHelpers.js'

describe('LocationDialogAssetGrid',
  ->
    beforeEach (done) ->
      $('#fixtures').html('<div id="test-location-dialog-asset-grid"></div>')
      @collection = new AssetCollection().add(AssetTestData)
      @view = new LocationDialogAssetGrid
        el: '#fixtures #test-location-dialog-asset-grid'
        collection: @collection
      done()

    afterEach (done) ->
      $('#fixtures').html('')
      @view = {}
      done()

    it 'should exist',
      (done) ->
        expect(LocationDialogAssetGrid).to.exist
        done()

    it 'should be a Backbone View',
      (done) ->
        @view.should.be.an.instanceof Backbone.View
        done()

    it 'should be an AssetCollectionAssetGrid',
      (done) ->
        @view.should.be.an.instanceof AssetCollectionAssetGrid
        done()

    it 'should be an AssetGrid',
      (done) ->
        @view.should.be.an.instanceof AssetGrid
        done()

    it '#template should be editorAssetThumbnails',
      (done) ->
        @view.template.should.deep.equal editorAssetsThumbnails
        done()

    it 'should have a filter member',
      (done) ->
        expect(@view.filter).to.exist
        done()

    it '#filter should leave only images in #collection',
      (done) ->
        @view.filter().should.satisfy (collection) ->
          _.every collection.models,
            (item) -> _.contains(["image/png", "image/jpeg"], ContentTypeHelpers.extensionToContentType(item.get('filename')))
        done()

    it 'should render a grid into the view',
      (done) ->
        @view.$el.html().should.not.equal ''
        done()
    
)