chai = require('chai')
should = chai.should()
{describe} = require '../../describe.coffee'
{expect} = chai
$ = require 'jquery-browserify'
Backbone = require 'backbone'
Backbone.$ = $
{AssetCollection} = require '../../../../../dist/asset/model/AssetCollection.js'
{AssetModel}= require '../../../../../dist/asset/model/AssetModel.js'

describe('AssetCollection',
  ->
    beforeEach (done) ->
      @assetCollection = new AssetCollection()
      done()

    afterEach (done) ->
      @assetCollection = {}
      done()

    it 'should exist',
      (done) ->
        expect(AssetCollection).to.exist
        done()

    it 'should be a Backbone.Collection instance',
      (done) ->
        @assetCollection.should.be.an.instanceof Backbone.Collection
        done()

    it 'should have a model property',
      (done) ->
        expect(@assetCollection.model).to.exist
        done()

    it '#model should be AssetModel',
      (done) ->
        @assetCollection.model.should.deep.equal AssetModel
        done()

    it 'should have a url property',
      (done) ->
        expect(@assetCollection.url).to.exist
        done()

    it '#url should be "/_/api/asset"',
      (done) ->
        @assetCollection.url.should.equal '/_/api/asset'
        done()
)