chai = require('chai')
should = chai.should()
{describe} = require '../../describe.coffee'
{expect} = chai
$ = require 'jquery-browserify'
Backbone = require 'backbone'
Backbone.$ = $
{AssetModel} = require '../../../../../dist/asset/model/AssetModel.js'

describe('AssetModel',
  ->
    beforeEach (done) ->
      @assetModelTestData =
        filename: "myFile.jpg"
        description: "some description"
        contentType: "image/jpg"
        labels: [
          "label1"
          "label2"
          "label3"
        ]
      @model = new AssetModel(@assetModelTestData)
      done()

    afterEach (done) ->
      @assetModelTestData = @model = {}
      done()

    it 'should exist',
      (done) ->
        expect(AssetModel).to.exist
        done()

    it 'should be a Backbone.Model instance',
      (done) ->
        @model.should.be.an.instanceof Backbone.Model
        done()

    it 'should have a filename attribute',
      (done) ->
        @model.has('filename').should.be.true
        done()

    it 'filename should be assetModelTestData.filename',
      (done) ->
        @model.get('filename').should.equal @assetModelTestData.filename
        done()

    it 'should have a description attribute',
      (done) ->
        @model.has('description').should.be.true
        done()

    it 'description should be assetModelTestData.description',
      (done) ->
        @model.get('description').should.equal @assetModelTestData.description
        done()

    it 'should have a contentType attribute',
      (done) ->
        @model.has('contentType').should.be.true
        done()

    it 'contentType should be assetModelTestData.contentType',
      (done) ->
        @model.get('contentType').should.equal @assetModelTestData.contentType
        done()

    it 'should have a labels attribute',
      (done) ->
        @model.has('labels').should.be.true
        done()

    it 'labels should be assetModelTestData.labels',
      (done) ->
        @model.get('labels').should.deep.equal @assetModelTestData.labels
        done()

    it 'labels should be an Array',
      (done) ->
        @model.get('labels').should.be.an.instanceof Array
        done()
)