chai = require 'chai'
sinon = require 'sinon'
sinonChai = require 'sinon-chai'
chai.use(sinonChai)
should = chai.should()
{expect} = chai
Handlebars = require 'handlebars'
{describe} = require './describe.coffee'
{uploadItem} = require '../../../dist/templates.js'

replaceWhitespaceRegex = ///\s{2,}///g

describe('templates',
  ->
    describe('#uploadItem',
      ->
        it 'should exist',
          (done) ->
            expect(uploadItem).to.exist
            done()

        it 'should be a function',
          (done) ->
            uploadItem.should.be.an.instanceof Function
            done()

        it 'should output the expected output',
          (done) ->
            context =
              id: 123
              filename : "test.jpg"
              size : 51200/1024
              hasError : false
              valid : true
              autoUpload : false
              progress: 35
              startMsg : "Upload File"
              cancelMsg : "Cancel Upload"

            uploadItem(context).replace(replaceWhitespaceRegex, "").should.equal """<tr id="123" class="template-upload"><td class="name"><span>test.jpg</span></td><td class="size"><span>50KB</span></td><td><div class="progress progress-success progress-striped active"><div class="bar" style="width:35%;"></div></div></td><td class="start"><button class="btn"><span>Upload File</span></button></td><td class="cancel"><button class="btn"><span>Cancel Upload</span></button></td></tr>"""
            done()

        it 'should output the expected output when there is an error',
          (done) ->
            context =
              id: 123
              filename: "test.jpg"
              size: 51200/1024
              hasError: true
              valid: true
              autoUpload: true
              progress: 35
              cancelMsg: "Cancel Upload"
              error:
                msg: "Lost Connection To Server."

            uploadItem(context).replace(replaceWhitespaceRegex, "").should.equal """<tr id="123" class="template-upload"><td class="name"><span>test.jpg</span></td><td class="size"><span>50KB</span></td><td class="error" colspan="2"><span class="label label-important">Lost Connection To Server.</span></td></tr>"""
            done()
    )
)